﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
'	--- XUI views
	Private Base As B4XView
	Private Dialog As B4XDialog
	
'	--- XUI views
	Private xui As XUI 'ignore
	Private Base As B4XView
	Private Dialog As B4XDialog
		
	Public TTS1 As M3TTS
	Type ItemData(ID As Int, Name As String, Code As String, HelpMsg As String)
	Private B4XComboBoxSimpleList As B4XComboBox
	Private ListOfUserTypes As List
	Public voiceLanguage As String
	
	Private btnSpeak As Button
	Private btnTest As Button
	Private btnSetup As Button
	
	Private ftxtName As B4XFloatTextField
	Private ftxtId As B4XFloatTextField
	Private lblTextToSpeak As Label
	
	Private lblCboVoices As Label
	Private cboVoices As B4XComboBox
	
	Private lblBarPitch As Label
	Private barPitch As B4XSeekBar
	
	Private lblBarSpeechRate As Label
	Private barSpeechRate As B4XSeekBar
	
	Private txtToSpeak As EditText
	Private txtHelp As EditText
	Private HelpHexStr As String
	
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
'	Root.LoadLayout("frmM3TTSdiag")
	
	Root.LoadLayout("frmTTSDesign")
	
	Base = Root
	Dialog.Initialize (Base)
	Dialog.Title = "TTS examples"
	
	
		
	ListOfUserTypes.Initialize
	
	barPitch_ValueChanged(33)		' --- Standard pitch = 1.0
	barSpeechRate_ValueChanged(34)		' --- Standard speech = 1.0
	txtToSpeak.Text = "This is a B4A text voice."

'	--- Init the TTS
	Activity_Resume
	Sleep(900)	'--- give time to start TTS
	
	
'	--- Add the voice text options
	
	
'	--- Add the voices and make "en" the default language

	initDefaultTexts
'	--- Set the DataSource property of the ComboBox to the list of objects
'	--- Direct load doesn't work
	Dim lst As List = TTS1.getVoicesList()
	cboVoices.SetItems(lst)
'	Log(TTS1.getVoicesList())
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub cboStandardText_SelectedIndexChanged (Index As Int)
	'We use the index of the selected item in the ComboBox to reference back into our list of UserType Objects
	'and pull out the object that was the source for the Combobox entry
'	Dim selectedItem As ItemData
'	selectedItem = ListOfUserTypes.Get(Index)
'	ToastMessageShow(selectedItem.code, False)
'	txtToSpeak.Text = selectedItem.Code
'	'Now we've got it, we can display its values.

End Sub


#Region XUIviews
#IF B4I
Private Sub Page1_Resize(Width As Int, Height As Int)
   If Dialog.Visible Then Dialog.Resize(Width, Height)
End Sub

Private Sub Application_Background
   Dialog.Close(XUI.DialogResponse_Cancel)
End Sub
#End If

#if B4A
Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK And Dialog.Close(xui.DialogResponse_Cancel) Then Return True
	Return False
End Sub

Sub Activity_Resume
	
	If TTS1.IsInitialized = False Then
		TTS1.Initialize("TTS1")
	End If
	
	'required to continue the animation after the activity is paused (only needed when not using B4XPages)
'	AnotherProgressBar1.Visible = True
'	B4XLoadingIndicator1.Show
'	B4XLoadingIndicator2.Show
'	ScrollingLabel1.Text = ScrollingLabel1.Text
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	TTS1.Release
	Dialog.Close (xui.DialogResponse_Cancel)
End Sub

#End If

#IF B4J
Sub MainForm_Resize (Width As Double, Height As Double)
   If Dialog.Visible Then Dialog.Resize(Width, Height)
End Sub
#End If

#End Region '--- XUIViews



Private Sub btnText1_Click
	txtToSpeak.Text = $"<speak>
<prosody rate="medium">Recharge your vehicle's air conditioning system and keep the cold air flowing
 through by using a quality r134a refrigerant from AutoZone.<break time="500ms"/> This cooling agent
 ensures that your ride's AC system is working properly, which is especially useful during those
 heat-filled summer months.<break time="500ms"/> Add the ultimate touch to your vehicle's air
 conditioning system by choosing a top-notch automotive refrigerant from<break time="500ms"/>
 AutoZone's premium selection.</prosody></voice>
  </speak>"$
End Sub

Private Sub btnText2_Click
	txtToSpeak.Text = $"<speak>
 <voice gender="male"><prosody rate="medium">What would you like To order?
   You can speak the part number Or keyword.</prosody></voice>
   <say-As interpret-As='telephone'>06 02 56 76 13</say-as>
   <say-As interpret-As="verbatim">abcdefg</say-As>
	</speak>"$		
End Sub

Private Sub btnText3_Click
	txtToSpeak.Text = $"<speak>
 <voice gender="male"><prosody rate="medium">This Autozone is open until 9pm today.
 If you would like to speak to a representative, press 1.</prosody></voice>	
	</speak>"$		
End Sub

Private Sub btnText4_Click
	txtToSpeak.Text = $"<speak>
 <voice gender="male">
  <prosody rate="medium">
    <emphasis>Hello<break time="1s"/></emphasis>
    <emphasis level="strong">this Is the Auto Zone BOT</emphasis><break time="500ms"/>
    You can say place order, store information, directions, store hours Or something Else.
  </prosody>
  That is a huge bank account!
  That is a <emphasis level="strong"> huge </emphasis> bank account!
	  Il préfère les pâtes
	<lang xml:lang="it-IT">
	    mozarella
	</lang>.
	Appuyer sur le bouton
	<lang xml:lang="en-UK">
	    Start
	</lang> et ensuite vous pouvez commencer.
	<lang xml:lang="en-UK">Ready?</lang>
	
</voice>	
                <prosody duration="10s">
                    Faites un pas à droite, levez le genou gauche, et changez de côté.
                </prosody>
                <prosody duration="2s">
                    Faites un pas à droite, levez le genou gauche, et changez de côté.
                </prosody>
	</speak>"$	
End Sub



#Region DefaultTexts
Public Sub initDefaultTexts
	'This populates a List with a series of objects of type ItemData
	Dim i As Int = 0
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	singleItem.HelpMsg = $"
Create and test your own TTS command(s)
"$
	i = i + 1
	singleItem.Name = "Empty text"
	singleItem.Code = $"
<speak>
 
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Speech example 1"
	singleItem.HelpMsg = $"
Speech combined cardinal, numbers and pause.
"$
	singleItem.Code = $"
<speak>
 Below we demonstrate  <say-as interpret-as="characters">SSML</say-as> samples.
You can pause <break time="3s"/>.
  You can use it for speaking in cardinals. The number is <say-as interpret-as="cardinal">11</say-as>.
Also, you can use it for speaking in ordinals. I am <say-as interpret-as="ordinal">11</say-as> in line.
You can use it for speaking in digits. The digits for eleven are <say-as interpret-as="characters">11</say-as>.
 Phrases can be substituted, like the <sub alias="United States of America">USA</sub>.
  Finally, I can speak a paragraph with two sentences.
  <p><s>Here is sentence one.</s><s>Here is sentence two.</s></p>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = 1
	singleItem.Name = "Speech example 2"
	singleItem.HelpMsg = $"
Speech combined cardinal, numbers and pause.	
"$

	singleItem.Code = $"
<speak>
Here are <say-as interpret-as="characters">SSML</say-as> samples.
 I can pause <break time="3" />.
 I can play a sound <audio src="https://www.example.com/MY_WAVE_FILE.wav">your wave file</audio>.
 I can speak in cardinals. Your position is <say-as interpret-as="cardinal">10</say-as> in line.
 Or I can speak in ordinals. You are <say-as interpret-as="ordinal">10</say-as> in line.
 Or I can even speak in digits. Your position in line is <say-as interpret-as="digits">10</say-as>.
 I can also substitute phrases, like the <sub alias="World Wide Web Consortium">W3C</sub>.
 Finally, I can speak a paragraph with two sentences.
 <p><s>This is sentence one.</s><s>This is sentence two.</s></p>
</speak>"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Speech example 3"
	singleItem.HelpMsg = $"
Speech combined break, moderated and media example
"$
	singleItem.Code = $"
<speak>
 <par>
    <media xml:id='question'>
      <speak>
        When was Wikipedia launched? <break time='5s'/>
        Was it 2000?<break time='2s'/>
        Or 2001 <break time='2s'/>
        Or 2002? <break time='2s'/>
        What is your answer?<break time='5s'/>
        <emphasis level="moderate">It was 2001!</emphasis>
        Wikipedia was launched on 15 January 2001, two days after the domain was registered by Jimmy Wales and Larry Sanger.
      </speak>
    </media>
    <media repeatDur='60s' soundLevel="-15dB" end='question.end+0s'>
      <audio src="https://storage.googleapis.com/aogssml/background_music_loop.ogg"/>
    </media>
  </par>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Media container example"
	singleItem.HelpMsg = $"
A parallel media container example enables playing multiple media elements simultaneously. Allowed content includes a set of 1 or more <par>, <seq>, and <media> elements. 
"$
	singleItem.Code = $"
<speak>
  <par>
    <media xml:id="question" begin="0.5s">
      <speak>Who invented the Internet?</speak>
    </media>
    <media xml:id="answer" begin="question.end+2.0s">
      <speak>The Internet was invented by cats.</speak>
    </media>
    <media begin="answer.end-0.2s" soundLevel="-6db">
      <audio
        src="https://actions.google.com/sounds/v1/cartoon/cartoon_boing.ogg"/>
    </media>
    <media repeatCount="3" soundLevel="+2.28dB"
      fadeInDur="2s" fadeOutDur="0.2s">
      <audio
        src="https://actions.google.com/sounds/v1/animals/cat_purr_close.ogg"/>
    </media>
  </par>
</speak>
"$
	ListOfUserTypes.Add(singleItem)

	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as example"
	singleItem.HelpMsg = $"
A Say-as interpret-as example 
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="spell-out">silvano</say-as> is how you spell out my name.
I am <say-as interpret-as="unit"> 1 .75 m </say-as> tall.
<say-as interpret-as="fraction">5+1/2</say-as> is a fraction.
<say-as interpret-as="expletive">censored</say-as> is something that I shouldn't be saying.
</speak>
"$
	ListOfUserTypes.Add(singleItem)
		
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "SSML <prosody> rate, pitch and volume example"
	singleItem.HelpMsg = $"
A SSML <prosody example which combine rate, pitch and volume.
"$
	singleItem.Code = $"
<speak>
Hello
<break/>
With SSML,
<prosody rate="fast">you can make speech fast.</prosody>
<prosody rate="slow">Or, make it slow.</prosody>
<prosody pitch="high">You can make it high.</prosody>
<prosody pitch="low">Or, you can make it low.</prosody>
<prosody volume="loud">You can make it loud.</prosody>
<prosody volume="soft">Or, you can make it quiet.</prosody>
<prosody rate="fast" pitch="low" volume="x-loud">Or all three things at once!</prosody>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	

	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<speak> root element of the TTS"
	singleItem.HelpMsg = $"
Simple text line without special pronunciation commands.
"$

	singleItem.Code = $"
<speak>
  my speech content
</speak>

"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<break> pausing between words"
	singleItem.HelpMsg = $"
An empty element that controls pausing or other prosodic boundaries between words. Using <break> between any pair of tokens is optional. If this element is not present between words, the break is automatically determined based on the linguistic context.	
time: Sets the length of the break by seconds or milliseconds (e.g. "3s" or "250ms").
strength: Sets the strength of the output's prosodic break by relative terms. Valid values are: "x-weak", weak", "medium", "strong", and "x-strong". The value "none" indicates that no prosodic break boundary should be outputted, which can be used to prevent a prosodic break that the processor would otherwise produce. The other values indicate monotonically non-decreasing (conceptually increasing) break strength between tokens. The stronger boundaries are typically accompanied by pauses.
"$

	singleItem.Code = $"
<speak>
  Step 1, take a deep breath. <break time="200ms"/>
  Step 2, exhale.
  Step 3, take a deep breath again. <break strength="weak"/>
  Step 4, exhale.
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as currency"
	singleItem.HelpMsg = $"
The following example is spoken as "forty two dollars and one cent". If the language attribute is omitted, it uses the current locale.	
"$

	singleItem.Code = $"
<speak>
 <say-as interpret-as='currency' language='en-US'>$42.01</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as telephone"
	singleItem.HelpMsg = $"
This example is spoken as "one eight zero zero two zero two one two one two". If the "google:style" attribute is omitted, it speaks zero as letter O.

The "google:style='zero-as-zero'" attribute currently only works in EN locales.
"$

	singleItem.Code = $"
<speak>
<say-as interpret-as='telephone' google:style='zero-as-zero'>1800-202-1212</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as verbatim or spell-out"
	singleItem.HelpMsg = $"
This following example is spelled out letter by letter	
"$

	singleItem.Code = $"
<speak>
<say-as interpret-as="verbatim">abcdefg</say-as>	
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as date detail 1"
	singleItem.HelpMsg = $"
This example is spelled out letter by letter:
"$

	singleItem.Code = $"
<speak>
<say-as interpret-as="date" format="yyyymmdd" detail="1">
1960-09-10
</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as date spoken"
	singleItem.HelpMsg = $"
Ths example is spoken as "The tenth of September":	
"$

	singleItem.Code = $"
<speak>
<say-as interpret-as="date" format="dm">10-9</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as date detail 2"
	singleItem.HelpMsg = $"
For detail='2' the day, month, and year fields are required and this is the default when all three fields are supplied. The spoken form is "{month} {ordinal day}, {year}".

The following example is spoken as "September tenth, nineteen sixty":	
"$

	singleItem.Code = $"
<speak>
 <say-as interpret-as="date" format="dmy" detail="2">
    10-9-1960
  </say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as characters"
	singleItem.HelpMsg = $"
The following example is spoken as "C A N":	
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="characters">can</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as cardinal"
	singleItem.HelpMsg = $"
The following example is spoken as "Twelve thousand three hundred forty five" (for US English) or "Twelve thousand three hundred and forty five (for UK English)":	
"$
	singleItem.Code = $"
<speak>
  <say-as interpret-as="cardinal">12345</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as ordinalt"
	singleItem.HelpMsg = $"
The following example is spoken as "First":	
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="ordinal">1</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as fraction"
	singleItem.HelpMsg = $"
The following example is spoken as "five and a half":	
"$
	singleItem.Code = $"
<speak>
  <say-as interpret-as="fraction">5+1/2</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as expletive or bleep"
	singleItem.HelpMsg = $"
The following example comes out as a beep, as though it has been censored:	
"$
	singleItem.Code = $"
<speak>
<say-As interpret-As="expletive">censor this</say-As>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as unit"
	singleItem.HelpMsg = $"
Converts units to singular or plural depending on the number. The following example is spoken as "10 feet":	
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="unit">10 foot</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Say-as time"
	singleItem.HelpMsg = $"
The following example is spoken as "Two thirty P.M." The format attribute is a sequence of time field character codes. Supported field character codes in format are {h,m, s, Z, 12, 24} for hour, minute (of the hour), second (of the minute), time zone, 12-hour time, and 24-hour time respectively. If the field code appears once for hour, minute, or second then the number of digits expected are 1, 2, and 2 respectively. If the field code is repeated then the number of expected digits is the number of times the code is repeated. Fields in the time text may be separated by punctuation and/or spaces. If hour, minute, or second are not specified in the format or there are no matching digits then the field is treated as a zero value. The default format is "hms12".

The detail attribute controls whether the spoken form of the time is 12-hour time or 24-hour time. The spoken form is 24-hour time if detail='1' or if detail is omitted and the format of the time is 24-hour time. The spoken form is 12-hour time if detail='2' or if detail is omitted and the format of the time is 12-hour time.	
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="time" format="hms12">2:30pm</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<audio> MP3 Ogg WAV (max 240 sec and max 5 megabyte)"
	singleItem.HelpMsg = $"
src: The required URI referring to the audio media source. Supported protocol is https.
clipBegin (0): A TimeDesignation that is the offset from the audio source's beginning to start playback from. If this value is greater than or equal to the audio source's actual duration, then no audio is inserted.
clipEnd (infinity): A TimeDesignation that is the offset from the audio source's beginning to end playback at. If the audio source's actual duration is less than this value, then playback ends at that time. If clipBegin is greater than or equal to clipEnd, then no audio is inserted.
speed (100%): The ratio output playback rate relative to the normal input rate expressed as a percentage. The format is a positive Real Number followed by %. The currently supported range is [50% (slow - half speed), 200% (fast - double speed)]. Values outside that range may (or may not) be adjusted to be within it.
repeatCount (1, or 10 if repeatDur is set): A Real Number specifying how many times to insert the audio (after clipping, if any, by clipBegin and/or clipEnd). Fractional repetitions aren't supported, so the value will be rounded to the nearest integer. Zero is not a valid value and is therefore treated as being unspecified and has the default value in that case.
repeatDur (infinity): A TimeDesignation that is a limit on the duration of the inserted audio after the source is processed for clipBegin, clipEnd, repeatCount, and speed attributes (rather then the normal playback duration). If the duration of the processed audio is less than this value, then playback ends at that time.
soundLevel (+0dB): Adjust the sound level of the audio by soundLeveldecibels. Maximum range is +/-40dB but actual range may be effectively less, and output quality may not yield good results over the entire range.
Format: MP3 (MPEG v2)

    24K samples per second
    24K ~ 96K bits per second, fixed rate

Format: Opus in Ogg

    24K samples per second (super-wideband)
    24K - 96K bits per second, fixed rate

Format (deprecated): WAV (RIFF)

    PCM 16-bit signed, little endian
    24K samples per second
"$
	singleItem.Code = $"
<speak>
<audio src="cat_purr_close.ogg">
    <desc>a cat purring</desc>
    PURR (sound didn't load)
</audio>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<p>,<s>"
	singleItem.HelpMsg = $"
Sentence and paragraph elements.
Best practices

    Use <s>...</s> tags to wrap full sentences, especially if they contain SSML elements that change prosody (that is, <audio>, <break>, <emphasis>, <par>, <prosody>, <say-as>, <seq>, and <sub>).
    If a break in speech is intended to be long enough that you can hear it, use <s>...</s> tags and put that break between sentences.
"$
	singleItem.Code = $"
<speak>
<p><s>This is sentence one.</s><s>This is sentence two.</s></p>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<sub> pronunciation"
	singleItem.HelpMsg = $"
Indicate that the text in the alias attribute value replaces the contained text for pronunciation.

You can also use the sub element to provide a simplified pronunciation of a difficult-to-read word. The last example below demonstrates this use case in Japanese.	
"$
	singleItem.Code = $"
<speak>
<sub alias="World Wide Web Consortium">W3C</sub>
<sub alias="にっぽんばし">日本橋</sub>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<mark> reference a specific location"
	singleItem.HelpMsg = $"
An empty element that places a marker into the text or tag sequence. It can be used to reference a specific location in the sequence or to insert a marker into an output stream for asynchronous notification.
Note: Follow these guidelines when you use the mark element:

    Use the START and END marks instead of adding custom marks near the beginning or end of the SSML.
    Do not add consecutive marks in your SSML. Marks in rapid succession might not generate events. Additionally, if there is no audio generated between marks, then events won't be generated. For example, avoid doing the following:
    Sentence 1. <mark name=a><mark name=b> Sentence 2.
	
Note: For convenience, you automatically get START and END events in your responses for Interactive Canvas. These marks are not included in the W3 spec. 
"$
	singleItem.Code = $"
<speak>
Go from <mark name="here"/> here, to <mark name="there"/> there!
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<prosody> customize the pitch, speaking rate, and volume of text"
	singleItem.HelpMsg = $"
Used to customize the pitch, speaking rate, and volume of text contained by the element. Currently the rate, pitch, and volume attributes are supported.

The rate and volume attributes can be set according to the W3 specifications. There are three options for setting the value of the pitch attribute:
Note: The <prosody> tags should only be used around a full sentence. Enclosing words within a sentence may cause unwanted pauses in speech.	

Attribute name: The string ID for each mark.
Relative: Specify a relative value (e.g. "low", "medium", "high", etc) where "medium" is the default pitch.
Semitones: Increase or decrease pitch by "N" semitones using "+Nst" or "-Nst" respectively. Note that "+/-" and "st" are required.
Percentage: Increase or decrease pitch by "N" percent by using "+N%" or "-N%" respectively. Note that "%" is required but "+/-" is optional.
"$
	singleItem.Code = $"
<speak>
<prosody rate="slow" pitch="-2st">Can you hear me now?</prosody>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<emphasis> add or remove emphasis from text"
	singleItem.HelpMsg = $"
Used to add or remove emphasis from text contained by the element. The <emphasis> element modifies speech similarly to <prosody>, but without the need to set individual speech attributes.
Note: The <emphasis> tags should only be used around a full sentence. Enclosing words within a sentence may cause unwanted pauses in speech.

This element supports an optional "level" attribute with the following valid values:

    strong
    moderate
    none
    reduced

Example
The following example uses the <emphasis> element to make an announcement:	
"$
	singleItem.Code = $"
<speak>
<emphasis level="moderate">This is an important announcement</emphasis>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<par> multiple media elements at once"
	singleItem.HelpMsg = $"
A parallel media container that allows you to play multiple media elements at once. The only allowed content is a set of one or more <par>, <seq>, and <media> elements. The order of the <media> elements is not significant.

Unless a child element specifies a different begin time, the implicit begin time for the element is the same as that of the <par> container. If a child element has an offset value set for its begin or end attribute, the element's offset will be relative to the beginning time of the <par> container. For the root <par> element, the begin attribute is ignored and the beginning time is when SSML speech synthesis process starts generating output for the root <par> element (i.e. effectively time "zero").
Note: This element is not a standard SSML element and is provided as an extra feature of Text-to-Speech.	
"$
	singleItem.Code = $"
<speak>
  <par>
    <media xml:id="question" begin="0.5s">
      <speak>Who invented the Internet?</speak>
    </media>
    <media xml:id="answer" begin="question.end+2.0s">
      <speak>The Internet was invented by cats.</speak>
    </media>
    <media begin="answer.end-0.2s" soundLevel="-6dB">
      <audio
        src="https://actions.google.com/.../cartoon_boing.ogg"/>
    </media>
    <media repeatCount="3" soundLevel="+2.28dB"
      fadeInDur="2s" fadeOutDur="0.2s">
      <audio
        src="https://actions.google.com/.../cat_purr_close.ogg"/>
    </media>
  </par>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
		
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<seq> play media elements one after another."
	singleItem.HelpMsg = $"
A sequential media container that allows you to play media elements one after another. The only allowed content is a set of one or more <seq>, <par>, and <media> elements. The order of the media elements is the order in which they are rendered.

The begin and end attributes of child elements can be set to offset values (see Time Specification below). Those child elements' offset values will be relative to the end of the previous element in the sequence or, in the case of the first element in the sequence, relative to the beginning of its <seq> container.
Note: This element is not a standard SSML element and is provided as an extra feature of Text-to-Speech.	
"$
	singleItem.Code = $"
<speak>
  <seq>
    <media begin="0.5s">
      <speak>Who invented the Internet?</speak>
    </media>
    <media begin="2.0s">
      <speak>The Internet was invented by cats.</speak>
    </media>
    <media soundLevel="-6dB">
      <audio
        src="https://actions.google.com/.../cartoon_boing.ogg"/>
    </media>
    <media repeatCount="3" soundLevel="+2.28dB"
      fadeInDur="2s" fadeOutDur="0.2s">
      <audio
        src="https://actions.google.com/.../cat_purr_close.ogg"/>
    </media>
  </seq>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<media> media layer within a <par> or <seq> element. "
	singleItem.HelpMsg = $"
Represents a media layer within a <par> or <seq> element. The allowed content of a <media> element is an SSML <speak> or <audio> element. The following table describes the valid attributes for a <media> element.
Note: This element is not a standard SSML element and is provided as an extra feature of the Actions on Google platform.
Attributes
xml:id (no value): A unique XML identifier for this element. Encoded entities are not supported. The allowed identifier values match the regular expression "([-_#]|\p{L}|\p{D})+". See XML-ID for more information.
begin (0): The beginning time for this media container. Ignored if this is the root media container element (treated the same as the default of "0"). See the Time specification section below for valid string values.
end (no value): A specification for the ending time for this media container. See the Time specification section below for valid string values.
repeatCount (1): A Real Number specifying how many times to insert the media. Fractional repetitions aren't supported, so the value will be rounded to the nearest integer. Zero is not a valid value and is therefore treated as being unspecified and has the default value in that case.
repeatDur (no value): A TimeDesignation that is a limit on the duration of the inserted media. If the duration of the media is less than this value, then playback ends at that time.
soundLevel (+0dB): Adjust the sound level of the audio by soundLevel decibels. Maximum range is +/-40dB but actual range may be effectively less, and output quality may not yield good results over the entire range.
fadeInDur (0s): A TimeDesignation over which the media will fade in from silent to the optionally-specified soundLevel. If the duration of the media is less than this value, the fade in will stop at the end of playback and the sound level will not reach the specified sound level.
fadeOutDur (0s): A TimeDesignation over which the media will fade out from the optionally-specified soundLevel until it is silent. If the duration of the media is less than this value, the sound level is set to a lower value to ensure silence is reached at the end of playback.
Time specification

A time specification, used for the value of `begin` and `end` attributes of <media> elements and media containers (<par> and <seq> elements), is either an offset value (for example, +2.5s) or a syncbase value (for example, foo_id.end-250ms).

    Offset value - Time offset value is an SMIL Timecount-value that allows values that match the regular expression: "\s\*(+|-)?\s\*(\d+)(\.\d+)?(h|min|s|ms)?\s\*"

    The first digit string is the whole part of the decimal number and the second digit string is the decimal fractional part. The default sign (i.e. "(+|-)?") is "+". The unit values correspond to hours, minutes, seconds, and milliseconds respectively. The default for the units is "s" (seconds).
    Syncbase value - A syncbase value is an SMIL syncbase-value that allows values that match the regular expression: "([-_#]|\p{L}|\p{D})+\.(begin|end)\s\*(+|-)\s\*(\d+)(\.\d+)?(h|min|s|ms)?\s\*"

    The digits and units are interpreted in the same way as an offset value.
"$
	singleItem.Code = $"
<speak>
@@
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<phoneme>"
	singleItem.HelpMsg = $"
You can use the <phoneme> tag to produce custom pronunciations of words inline. Text-to-Speech accepts the IPA and X-SAMPA phonetic alphabets. See the phonemes page for a list of supported languages and phonemes.

Note: Set the alphabet field to either ipa or x-sampa, depending on which phonetic alphabet you're using. The only exceptions are the Chinese languages, which must be specified as pinyin or jyutping. See the phonemes page to see which phonetic alphabets are available for you language.

Stress markers

There are up to three levels of stress that can be placed in a transcription:

    Primary stress: Denoted with /ˈ/ in IPA and /"/ in X-SAMPA.
    Secondary stress: Denoted with /ˌ/ in IPA and /%/ in X-SAMPA.
    Unstressed: Not denoted with a symbol (in either notation).

Some languages might have fewer than three levels or not denote stress placement at all. See the phonemes page to see the stress levels available for your language. Stress markers are placed at the start of each stressed syllable. For example, in US English:

Each application of the <phoneme> tag directs the pronunciation of a single word:
"$
	singleItem.Code = $"
<speak>
<phoneme alphabet="ipa" ph="ˌmænɪˈtoʊbə">manitoba</phoneme>
<phoneme alphabet="x-sampa" ph='m@"hA:g@%ni:'>mahogany</phoneme>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Durations"
	singleItem.HelpMsg = $"
Text-to-Speech supports <say-as interpret-as="duration"> to correctly read durations.

Abbreviation and Value
h 	hours
m 	minutes
s 	seconds
ms 	milliseconds

For example, the following example would be verbalized as "five hours and thirty minutes":
"$
	singleItem.Code = $"
<speak>
<say-as interpret-as="duration" format="h:m">5:30</say-as>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<voice>"
	singleItem.HelpMsg = $"
Example 1: The <voice> tag allows you to use more than one voice in a single SSML request. In the following example, the default voice is an English male voice. All words will be synthesized in this voice except for "qu'est-ce qui t'amène ici", which will be verbalized in French using a female voice instead of the default language (English) and gender (male). 
Example 2: Alternatively, you can use a <voice> tag to specify an individual voice (the voice name on the supported voices page) rather than specifying a language and/or gender:
When you use the <voice> tag, Text-to-Speech expects to receive either a name (the name of the voice you want to use) or a combination of the following attributes. All three attributes are optional but you must provide at least one if you don't provide a name.

    gender: One of "male", "female" or "neutral".
    variant: Used as a tiebreaker in cases where there are multiple possibilities of which voice to use based on your configuration.
    language: Your desired language. Only one language can be specified in a given <voice> tag. Specify your language in BCP-47 format. You can find the BCP-47 code for your language in the language code column on the supported voices and languages page.

You can also control the relative priority of each of the gender, variant, and language attributes using two additional tags: required and ordering.

    required: If an attribute is designated as required and not configured properly, the request will fail.
    ordering: Any attributes listed after an ordering tag are considered as preferred attributes rather than required. The Text-to-Speech API considers preferred attributes on a best effort basis in the order they are listed after the ordering tag. If any preferred attributes are configured incorrectly, Text-to-Speech might still return a valid voice but with the incorrect configuration dropped.

Examples 3 and 4: Configurations using the required and ordering tags:
"$
	singleItem.Code = $"
<speak>And then she asked, <voice language="fr-FR" gender="female">qu'est-ce qui
t'amène ici</voice><break time="250ms"/> in her sweet and gentle voice.

<break time="900ms"/>

The dog is friendly<voice name="fr-CA-Wavenet-B">mais la chat est
mignon</voice><break time="250ms"/> said a pet shop
owner
</speak>

<break time="900ms"/>

<speak>And there it was <voice language="en-GB" gender="male" required="gender"
ordering="gender language">a flying bird </voice>roaring in the skies for the
first time.</speak>

<break time="900ms"/>

<speak>Today is supposed to be <voice language="en-GB" gender="female"
ordering="language gender">Sunday Funday.</voice></speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "<lang>"
	singleItem.HelpMsg = $"
You can use <lang> to include text in multiple languages within the same SSML request. All languages will be synthesized in the same voice unless you use the <voice> tag to explicitly change the voice. The xml:lang string must contain the target language in BCP-47 format (this value is listed as "language code" in the supported voices table).

Text-to-Speech supports the <lang> tag on a best effort basis. Not all language combinations produce the same quality results if specified in same SSML request. In some cases, a language combination might produce an effect that is detectible but subtle or perceived as negative. Known issues:

    Japanese with Kanji characters is not supported by the <lang> tag. The input is transliterated and read as Chinese characters.
    Semitic languages such as Arabic, Hebrew, and Persian are not supported by the <lang> tag and will result in silence. If you want to use any of these languages we recommend using the <voice> tag to switch to a voice that speaks your desired language (if available).

In the following example "chat" will be verbalized in French instead of the default language (English):
"$
	singleItem.Code = $"
<speak>
<speak>The french word for cat is <lang xml:lang="fr-FR">chat</lang></speak>
</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "SSML timepoints"
	singleItem.HelpMsg = $"
The Text-to-Speech API supports the use of timepoints in your created audio data. A timepoint is a timestamp (in seconds, measured from the beginning of the generated audio) that corresponds to a designated point in the script. You can set a timepoint in your script using the <mark> tag. When the audio is generated, the API then returns the time offset between the beginning of the audio and the timepoint.

There are two steps to setting a timepoint:

    Add a <mark> SSML tag to the point in the script that you want a timestamp for.
    Set TimepointType to SSML_MARK. If this field is not set, timepoints are not returned by default.

The following example returns two timepoints:

    timepoint_1: Indicates the time (in seconds) that the word "Mark" appears in the generated audio.
    timepoint_2: Indicates the time (in seconds) that the word "see" appears in the generated audio.
"$
	singleItem.Code = $"
<speak>
<speak>Hello <mark name="timepoint_1"/> Mark. Good to <mark
name="timepoint_2"/> see you.</speak>
</speak>
"$
	ListOfUserTypes.Add(singleItem)


	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)

	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)

	
	Dim singleItem As ItemData
	singleItem.Initialize
	singleItem.ID = i
	i = i + 1
	singleItem.Name = "Emptyt"
	singleItem.HelpMsg = $"
@@@@
"$
	singleItem.Code = $"
<speak>

</speak>
"$
	ListOfUserTypes.Add(singleItem)
	


	B4XComboBoxSimpleList.cmbBox.DropdownBackgroundColor = Colors.LightGray
	
	'Now we iterate (go through) the list and pick out the bit we want displayed on the ComboBox
	For Each individualitem As ItemData In ListOfUserTypes
		B4XComboBoxSimpleList.cmbBox.Add(individualitem.Name)
	Next
	
	'Point to the first item on the list
'	B4XComboBoxSimpleList.SelectedIndex = 0
	B4XComboBoxSimpleList_SelectedIndexChanged(0)
End Sub


Sub B4XComboBoxSimpleList_SelectedIndexChanged (Index As Int)
	'We use the index of the selected item in the ComboBox to reference back into our list of UserType Objects
	'and pull out the object that was the source for the Combobox entry
	Dim selectedItem As ItemData
	selectedItem = ListOfUserTypes.Get(Index)
	
	'Now we've got it, we can display its values.
	ftxtId.Text = selectedItem.Name
	ftxtName.text = selectedItem.Name
	txtToSpeak.Text = selectedItem.Code
	HelpHexStr = selectedItem.HelpMsg
	If HelpHexStr.Trim = "@@" Then
		txtHelp.Text = "Sorry no help text availible." 
	Else
		txtHelp.Text = HelpHexStr
	End If
	
End Sub


#End Region ' DefaultTets


Sub TTS1_Ready (Success As Boolean)
	If Success Then
'		--- Now we enable all views which were previously disabled in the designer.
		'enable all views
		For i = 0 To Root.NumberOfViews - 1
			' Create the view
			Dim myView As B4XView = Root.GetView(i) ' Get the first view in the layout
			myView.Enabled = True
		Next
		btnSpeak_Click 'play first sentence
	Else
		MsgboxAsync("Error initializing TTS engine.", "")
		
	End If
End Sub


Private Sub btnSetup_Click
		
	Dim i As Intent
	i.Initialize("com.android.settings.TTS_SETTINGS", "")
	StartActivity(i)      ' or StartActivityForResult, depending
End Sub

Private Sub btnTest_Click
	txtToSpeak.Text = $"<speak>
 <voice gender="male">
  <prosody rate="medium">
    <emphasis>Hello<break time="1s"/></emphasis>
    <emphasis level="strong">this Is the Auto Zone BOT</emphasis><break time="500ms"/>
    You can say place order, store information, directions, store hours Or something Else.
  </prosody>
  That is a huge bank account!
  That is a <emphasis level="strong"> huge </emphasis> bank account!
	  Il préfère les pâtes
	<lang xml:lang="it-IT">
	    mozarella
	</lang>.
	Appuyer sur le bouton
	<lang xml:lang="en-UK">
	    Start
	</lang> et ensuite vous pouvez commencer.
	<lang xml:lang="en-UK">Ready?</lang>
	
</voice>	
                <prosody duration="10s">
                    Faites un pas à droite, levez le genou gauche, et changez de côté.
                </prosody>
                <prosody duration="2s">
                    Faites un pas à droite, levez le genou gauche, et changez de côté.
                </prosody>
	</speak>"$	
	Dim M3Tts As M3TTS
	If M3Tts.IsInitialized = False Then
		M3Tts.Initialize("M3Tts")
	End If
	Sleep(100)	'--- give time to start TTS

	Log("===========")
	Log(M3Tts.test)
	Log("===========")

'	M3Tts.SetLanguage("fr", "FR")
'	M3Tts.Speak("This is a voice text", True, Null, "001")
End Sub

Private Sub btnSpeak_Click
'	--- Do we have text?
	If txtToSpeak.Text.Length > 0 Then
		TTS1.Speak(txtToSpeak.Text, True, Null, "1")
		txtToSpeak.SelectAll
	End If
End Sub

Private Sub barPitch_ValueChanged (Value As Int)
'	--- pitch from 0.5 till 2.0
	Dim DblValue As Double = (Value / 100) * 1.5 + 0.5
	lblBarPitch.Text = $"Pitch rate: ${DblValue}"$
'	Log($"Value: ${Value}, DblValue: ${DblValue}"$)
End Sub

Private Sub barSpeechRate_ValueChanged (Value As Int)
'	--- speech from 0.5 till 2.0
	Dim DblValue As Double = (Value / 100) * 1.5 + 0.5
	lblBarSpeechRate.Text = $"Speech rate: ${DblValue}"$
'	Log($"Value: ${Value}, DblValue: ${DblValue}"$)
End Sub

Private Sub cboVoices_SelectedIndexChanged (Index As Int)
'	Log(Index)
	cboVoices.SelectedIndex = Index
	Sleep(0)

	setSelectedvoice
End Sub


Sub spnrLanguages_ItemClick (Position As Int, Value As Object)
	If btnSpeak.Enabled = False Then Return
	If TTS1.SetLanguage(Value, "") = False Then
		#IF B4A
			ToastMessageShow("Language data not found.", True)
		#End If
		
		#IF B4J
			
		#End If
		
		Return
	End If
End Sub


Public Sub FillVoicesChoice (index As Int)
	'	--- Set the DataSource property of the ComboBox to the list of objects
	cboVoices.SetItems(TTS1.getVoicesList())
	
'	--- use the voice
	If btnSpeak.Enabled = False Then Return
	

	setSelectedvoice

End Sub


Private Sub setSelectedvoice()
		
'	--- split language, country, and voice
	Dim StrTextArray() As String
	StrTextArray = Regex.Split("-", cboVoices.SelectedItem)
	
'	--- set the voice
	voiceLanguage = StrTextArray(0)
	TTS1.SetLanguage(voiceLanguage, "")
'	Log($"Voice language = ${voiceLanguage}"$)
End Sub


